
let source = GetCurrentScriptDirectory~"/source/Stage/Stage0/";

let Screen = source ~ "screencover.png";
let bg1 = source ~ "world01.png";
let bg2 = source ~ "world02.png";
let bg3 = source ~ "world03.png";
let bg4 = source ~ "world04.png";

let stgspeed = 3;
let RunningCondition = true;
let SpellActive = false;

@Initialize{
	SetAutoDeleteObject(true);
	SetCommonData("stgspeed", 3);
	Stage1Bg;
}
@MainLoop{
	let a = GetEnemyBossSceneObjectID;
	stgspeed = GetCommonData("stgspeed", 3); // this should only be changed in the boss's final sc
	//a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL) | GetKeyState(KEY_H)!=KEY_FREE
	if(a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL)){SpellActive = true;}else{SpellActive = false;}
	if(stgspeed > 3){SpellActive = false;}
	RunningCondition = GetCommonData("quality", 2)!=0;
	yield;
}

task Stage1Bg{
	let ypos = 0;
	let xpos = 0;
	let wpos = 0;
	let cam = 0;
	
	SetCameraFocusX(0);
	SetCameraFocusY(0);
	SetCameraFocusZ(32);
	SetCameraRadius(300);
	SetCameraElevationAngle(285);
	SetCameraAzimuthAngle(90);
	
	let StageBGSky = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageBGSky, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBGSky, 255);
	ObjPrim_SetTexture(StageBGSky, NULL);
	ObjSprite3D_SetSourceRect(StageBGSky, 0, 0, 0, 0);
	ObjSprite3D_SetDestRect(StageBGSky, -640, 0, 640, 1024);
	ObjRender_SetColor(StageBGSky, 16, 0, 6);
	ObjRender_SetFogEnable(StageBGSky, false);
	ObjRender_SetPosition(StageBGSky, 0, 1675, -500);
	ObjRender_SetAngleXYZ(StageBGSky, 90, 0, 0);
	Obj_SetRenderPriority(StageBGSky, 0.21);
	ObjRender_SetZWrite(StageBGSky, true);
	ObjRender_SetZTest(StageBGSky, true);
	
	let ScreenCover = CreateSimple2DImageA1(0.28, Screen);
	ObjRender_SetPosition(ScreenCover, GetStgFrameWidth/2+32, GetStgFrameHeight/2+16, 0);
	ObjRender_SetColor(ScreenCover, min(176, 48*stgspeed), 0, min(128, 16*stgspeed));
	ObjRender_SetAlpha(ScreenCover, min(255, 48*stgspeed));
	ObjRender_SetPermitCamera(ScreenCover, false);
	
	//SetFogEnable(false);
	//SetFogParam(600, 1000, 64, 64, 64);
	
	let vcount = 32;
	let cave = CreateCircleCaveA1(bg1, vcount, 256, 1650);
	CreateSunClusterA1(200, 900, -200, 96, 204, 0, 190, 0.85, 3);
	CreateSunClusterA1(-125, 400, 100, 0, 204, 16, 64, 1.15, 3);
	CreateMagicCircle(0.15);
	CreateMagicCircle(-0.15);
	CreateCloudBrushY1;
	//CreateSunBrushA1(1);
	
	//CameraFlight;
	
	while(RunningCondition){
		RenderBG;
		yield;
	}
	Obj_Delete(cave);
	Obj_Delete(StageBGSky);
	Obj_Delete(ScreenCover);
	CloseScript(GetOwnScriptID);
	
	sub RenderBG{
		cam+=stgspeed/3;
		xpos += stgspeed;
		Obj_SetVisible(cave, !SpellActive);
		Obj_SetVisible(StageBGSky, !SpellActive);
		Obj_SetVisible(ScreenCover, !SpellActive);
		ObjRender_SetColor(ScreenCover, min(176, 48*stgspeed), 0, min(128, 16*stgspeed));
		ObjRender_SetAlpha(ScreenCover, min(255, 48*stgspeed));
		ascent(i in 0..vcount/2){
			let ivert = i*2;
			ObjPrim_SetVertexUVT(cave, ivert+0, xpos, 256*4/vcount*i);
			ObjPrim_SetVertexUVT(cave, ivert+1, 192+xpos, 256*4/vcount*i);
		}
		SetCameraRoll(sin(cam*0.1)*6);
		SetCameraYaw(sin(cam*0.5)*6);
		SetCameraPitch(sin(cam*0.1)*2);
	}
}


function CreateCircleCaveA1(texture, vcount, width, length){
	let obj = ObjPrim_Create(OBJ_PRIMITIVE_3D);
	ObjPrim_SetPrimitiveType(obj, PRIMITIVE_TRIANGLESTRIP);
	ObjRender_SetAngleXYZ(obj, 0, -90, 0);
	
	ObjPrim_SetVertexCount(obj, vcount);
	ObjPrim_SetTexture(obj, texture);
	Obj_SetRenderPriority(obj, 0.23);
	let wcount = vcount/2;
	ascent(i in 0..vcount/2){
		let ivert = i*2;
		let angle = 360/(vcount/2-1)*i;
		ObjPrim_SetVertexUVT(obj, ivert+0, 96, 512*4/vcount*i);
		ObjPrim_SetVertexUVT(obj, ivert+1, 512+96, 512*4/vcount*i);
		ObjPrim_SetVertexPosition(obj, ivert+0, width*cos(angle), 0, width*sin(angle));
		ObjPrim_SetVertexPosition(obj, ivert+1, width*cos(angle), length, width*sin(angle));
	}
	return obj;
}

task CreateMagicCircle(dir){
	let sangle = 0;
	let obj = Create3DBrush(255, 256, 0, bg3, 0.22);
	ObjSprite3D_SetDestRect(obj, -128, -128, 128, 128);
	ObjRender_SetPosition(obj, 0, 1650, 0);
	ObjRender_SetScaleXYZ(obj, 2, 2, 1);
	ObjRender_SetColor(obj, 128, 128, 128);
	while(RunningCondition){
		Obj_SetVisible(obj, !SpellActive);
		sangle += dir*(stgspeed/3);
		let cm = 96*max(0, sin(absolute(sangle*6)+90));
		ObjRender_SetAngleXYZ(obj, 90, 0, sangle);
		ObjRender_SetColor(obj, 96+cm, 96+cm, 96+cm);
		yield;
	}
}

task CreateSunClusterA1(x, by, my, z, r, g, b, s, l){
	loop(l){CreateSun(0, s, 0, 0, rand(0.25, 0.85));}
	loop(l){CreateSun(0, s, 0, 0, rand(-0.25, -0.85));}
	
	loop(6){
		//dist, scale, langle, dir, spd
		let rp = [rand(-256, 256), rand(0.1, 0.2)*s, rand(0,360), round(rand(0, 1)), rand(0.05, 0.5)];
		while(absolute(rp[0]) < 96*s){rp[0] = rand(-256, 256);}
		if(rp[3] == 0){rp[3] = -1;}
		rp[4] = rp[4] * rp[3];
		CreateSun(rp[0], rp[1], rp[2], rp[4], rand(0.25, 0.85)*2);
		CreateSun(rp[0], rp[1], rp[2], rp[4], -rand(0.25, 0.85)*2);
	}

	task CreateSun(w, ls, langle, spd, mod){
		let sangle = rand(0,360);
		let movmod = 0;
		let obj = Create3DBrush(255, 512, 0, bg2, 0.25);
		ObjSprite3D_SetDestRect(obj, -256, -256, 256, 256);
		ObjRender_SetAngleXYZ(obj, 0, 0, sangle);
		ObjRender_SetScaleXYZ(obj, ls, ls, 1);
		let cm = 1-min(absolute(w), 0.25); //on the big suns, w is 0
		ObjRender_SetColor(obj, r*cm, g*cm, b*cm);
		ObjSprite3D_SetBillboard(obj, true);
		
		while(RunningCondition){
			Obj_SetVisible(obj, !SpellActive);
			sangle += mod;
			langle += spd*(stgspeed/3);
			movmod += stgspeed*0.02;
			ObjRender_SetPosition(obj, x*cos(movmod)+w*cos(langle), by+my*sin(movmod/2)+w*sin(langle)*0.5, my*sin(movmod)+z+w*sin(langle));
			ObjRender_SetAngleXYZ(obj, 0, 0, sangle);
			yield;
		}
		Obj_Delete(obj);
	}
}

task CreateSunBrushA1(l){
	loop{
		let rp = [rand(-256, 256), rand(-128, 128), rand(-256, 256), rand(0.05, 0.25)];
		while(absolute(rp[0]) < 96){rp[0] = rand(-256, 256);}
		while(absolute(rp[2]) < 96){rp[2] = rand(-256, 256);}
		
		let rc = [128+128*(1-rand(0,1)^2), 32*(rand(0,1)^2), 255*(1-rand(0,1)^2)];
		loop(l){
			CreateSun(rp[0], rp[1], rp[2], rc[0], rc[1], rc[2], rp[3], rand(0.25, 0.85));
			CreateSun(rp[0], rp[1], rp[2], rc[0], rc[1], rc[2], rp[3], -rand(0.25, 0.85));
		}
		loop(10){yield;}
	}
	
	task CreateSun(x, y, z, r, g, b, s, mod){
		let sangle = rand(0,360);
		let alpha = 0;
		let obj = Create3DBrush(255, 512, 0, bg2, 0.25);
		ObjSprite3D_SetDestRect(obj, -256, -256, 256, 256);
		ObjRender_SetPosition(obj, x, y, z);
		ObjRender_SetAngleXYZ(obj, 0, 0, sangle);
		ObjRender_SetScaleXYZ(obj, s, s, 1);
		ObjRender_SetColor(obj, r, g, b);
		ObjRender_SetAlpha(obj, alpha);
		ObjSprite3D_SetBillboard(obj, true);
		
		while(ObjRender_GetY(obj) < 1400 && s > 0){
			alpha = min(alpha + 2, 255);
			s = max(s-0.001, 0);
			ObjRender_SetScaleXYZ(obj, s, s, 1);
			ObjRender_SetAlpha(obj, alpha);
			RenderMovement;
			yield;
		}
		if(s<=0){Obj_Delete(obj); return;}
		ascent(i in 0..120){
			let sc = s-s/120*i;
			ObjRender_SetAlpha(obj, 255-255/120*i);
			ObjRender_SetScaleXYZ(obj, sc, sc, 1);
			RenderMovement;
			yield;
		}
		Obj_Delete(obj);
		
		sub RenderMovement{
			Obj_SetVisible(obj, !SpellActive);
			sangle += mod;
			ObjRender_SetAngleXYZ(obj, 0, 0, sangle);
			ObjRender_SetY(obj, ObjRender_GetY(obj)+stgspeed*2.5);
		}
	}
}

task CreateCloudBrushY1{

	loop{
		CreateCloudA1(200, 255, rand(-75, 75), rand(128, 1400)*(rand(0,1)^2), rand(-100, 32), rand(-0.75, 0.75), rand(-0.75, 0.15), rand(-1.5, 1.5));
		loop(8){yield};
	}
	
	
	task CreateCloudA1(time, amax, x, y, z, xv, yv, amod){
		let a = 0;
		let rang = rand(0,360);
		let obj = Create3DBrush(255, 256, 0, bg4, 0.24);
		ObjSprite3D_SetDestRect(obj, -128, -128, 128, 128);
		ObjRender_SetPosition(obj, x, y, z);
		ObjRender_SetAngleZ(obj, rang);
		ObjRender_SetColor(obj, 208, 0, 96);
		ObjSprite3D_SetBillboard(obj, true);
		let mod2 = rand(0.5, 1.15);
		descent(i in 0..time){
			Obj_SetVisible(obj, !SpellActive);
			let mod = i/time;
			let scm = mod^0.25;
			a = min(a+0.75, amax);
			x+=xv;
			y+=yv;
			z+=(xv+yv)*0.25;
			rang += amod;
			ObjRender_SetPosition(obj, x, y, z);
			ObjRender_SetScaleXYZ(obj, scm*mod2, scm*mod2, 1);
			ObjRender_SetAngleZ(obj, rang);
			ObjRender_SetAlpha(obj, a*mod^0.5);
			yield;
		}
		Obj_Delete(obj);
	}
}


function Create3DBrush(alpha, srcrect, offset, image, priority){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetAlpha(StageProp, alpha);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, priority);
	ObjSprite3D_SetSourceRect(StageProp, 0+offset, 0+offset, srcrect+offset, srcrect+offset);
	ObjSprite3D_SetDestRect(StageProp, 0, -srcrect/2, srcrect, srcrect/2); // Centered middle origin maybe
	//ObjRender_SetZWrite(StageProp, true);
	//ObjRender_SetZTest(StageProp, true);
	return StageProp;
}
function Create3DProperties(alpha, srcrect, image, priority){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetAlpha(StageProp, alpha);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, priority);
	ObjSprite3D_SetSourceRect(StageProp, 0, 0, srcrect, srcrect);
	ObjSprite3D_SetDestRect(StageProp, -srcrect, -srcrect, srcrect, srcrect);
	ObjRender_SetZWrite(StageProp, true);
	ObjRender_SetZTest(StageProp, true);
	return StageProp;
}

function Create3DEnvironment(image, srcrect, pri){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetY(StageProp, -64);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, pri);
	ObjSprite3D_SetSourceRect(StageProp, 0, 0, srcrect*4, srcrect*4);
	ObjSprite3D_SetDestRect(StageProp, -srcrect*2, 0, srcrect*2, srcrect*4);
	ObjRender_SetZWrite(StageProp, true);
	ObjRender_SetZTest(StageProp, true);
	return StageProp;
}

task BackgroundShakeA1(intensity, intdec){
	while(intensity>0){
		Set2DCameraFocusX(GetStgFrameWidth/2 + rand(-intensity, intensity));
		Set2DCameraFocusY(GetStgFrameHeight/2 + rand(-intensity, intensity));
		SetCameraFocusX(rand(-intensity, intensity));
		SetCameraFocusZ(100+rand(-intensity, intensity));
		intensity-=intdec;
		yield;
	}
	SetCameraFocusX(0);
	SetCameraFocusZ(100);
	Reset2DCamera;
	yield;
}

task CameraFlight{
	// Static Version
	let pos = [0,0,100];
	let ang = [90,295,300];
	let cammod = 1.25;
	loop{
		if(GetKeyState(KEY_J)==KEY_HOLD){pos[0]=pos[0]+5*cammod;}
		if(GetKeyState(KEY_L)==KEY_HOLD){pos[0]=pos[0]-5*cammod;}
		if(GetKeyState(KEY_I)==KEY_HOLD){pos[1]=pos[1]+5*cammod;}
		if(GetKeyState(KEY_K)==KEY_HOLD){pos[1]=pos[1]-5*cammod;}
		if(GetKeyState(KEY_U)==KEY_HOLD){pos[2]=pos[2]-5*cammod;}
		if(GetKeyState(KEY_O)==KEY_HOLD){pos[2]=pos[2]+5*cammod;}
		
		
		if(GetKeyState(KEY_Q)==KEY_HOLD){ang[0]=ang[0]+2*cammod;}
		if(GetKeyState(KEY_E)==KEY_HOLD){ang[0]=ang[0]-2*cammod;}
		if(GetKeyState(KEY_W)==KEY_HOLD){ang[1]=ang[1]+2*cammod;}
		if(GetKeyState(KEY_S)==KEY_HOLD){ang[1]=ang[1]-2*cammod;}
		if(GetKeyState(KEY_A)==KEY_HOLD){ang[2]=ang[2]+2*cammod;}
		if(GetKeyState(KEY_D)==KEY_HOLD){ang[2]=ang[2]-2*cammod;}
		
		SetCameraFocusX(pos[0]);
		SetCameraFocusY(pos[1]);
		SetCameraFocusZ(pos[2]);
		SetCameraAzimuthAngle(ang[0]);	
		SetCameraElevationAngle(ang[1]);
		SetCameraRadius(ang[2]);
		yield;
	}
}

function GetDistance(x1,y1,x2,y2){
	return(((x2-x1)^2+(y2-y1)^2)^(1/2))
}

function CreateSimple2DImageA1(pri, image){
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, pri);
	ObjPrim_SetTexture(obj, image);
	let test = [GetTextureWidth(image), GetTextureHeight(image)];
	ObjSprite2D_SetSourceRect(obj, 0, 0, test[0]-1, test[1]-1);
	ObjSprite2D_SetDestRect(obj, -(test[0]/2+0.5), -(test[1]/2), (test[0]/2), (test[1]/2));
	return obj;
}


task PlaySoundA1(name){
	let ID = -1;
	let GlobalSounds = GetCommonData("GlobalSoundData", [-1]);
	let GlobalSndStr = GetCommonData("GlobalSndStrData", [-1]);
	ascent(i in 0..length(GlobalSndStr)){
		if(GlobalSndStr[i]==name){ID = i; break;}
	}
	if(ID==-1){RaiseError("Error when attempting to play audio: "~name);}
	ObjSound_Play(GlobalSounds[ID]);
}

