
let current = GetCurrentScriptDirectory;
let spbg2 = current~"cdbg01.png";
let spbg1 = current~"cdbg01a.png";
let spbg3 = current~"cdbg01b.png";

@Initialize{
	SpellBG;
}
@MainLoop{
	yield;
}


task SpellBG{
	let fade = 0;
	let move = 0;
	let step = 0;
	
	let cdbg1a = CreateBackgroundImageA1(spbg1, 1, 0.27, 1);
	ObjSprite2D_SetSourceRect(cdbg1a, 0, 0, 384, 448);
	ObjSprite2D_SetDestRect(cdbg1a, 0, 0, 384, 448);
	ObjRender_SetAngleZ(cdbg1a, 0);
	ObjRender_SetColor(cdbg1a, 224, 224, 224);
	
	let cdbg2a = CreateBackgroundImageA1(spbg2, 1, 0.27, 1);
	ObjSprite2D_SetSourceRect(cdbg2a, 0, 0, 640, 640);
	ObjSprite2D_SetDestRect(cdbg2a, -320, -320, 320, 320);
	ObjRender_SetColor(cdbg2a, 128, 0, 16);
	
	let cdbg3a = CreateBackgroundImageA1(spbg3, 1, 0.27, 1);
	ObjRender_SetBlendType(cdbg3a, BLEND_ADD_RGB);
	ObjSprite2D_SetSourceRect(cdbg3a, 0, 0, 384, 448);
	ObjSprite2D_SetDestRect(cdbg3a, 0, 0, 384, 448);
	ObjRender_SetColor(cdbg3a, fade, fade, fade);
	Obj_SetVisible(cdbg3a, false); // looks awful but i'll keep it for later uses
	
	ObjRender_SetPosition(cdbg1a, 0, 0, 0);
	ObjRender_SetPosition(cdbg2a, GetStgFrameWidth/2, GetStgFrameHeight/2, 0);
	ObjRender_SetPosition(cdbg3a, 0, 0, 0);
	
	yield;
	while(!IsCloseScript(GetScriptArgument("PluralID"))){
		let a = GetEnemyBossSceneObjectID;
		if(GetCommonData("stgspeed", 3)<=3){
			ObjRender_SetAlpha(cdbg1a, fade);
			ObjRender_SetAlpha(cdbg2a, fade*0.65);
			ObjRender_SetScaleXYZ(cdbg2a, 1, 1, 1);
		}else{
			ObjRender_SetAlpha(cdbg1a, 96);
			ObjRender_SetAlpha(cdbg2a, fade*0.45);
			ObjRender_SetScaleXYZ(cdbg2a, 2, 2, 1);
		}
		ObjRender_SetColor(cdbg3a, fade*0.75, fade*0.75, fade*0.75);
		
		if((a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL))||GetCommonData("stgspeed", 3)>3){
			fade = min(fade+12.75, 255);
		}else{fade=0;}
		
		move+=0.5;
		step++;
		if(move>=1280){move = 0;}
		ObjSprite2D_SetSourceRect(cdbg2a, move, 0, 640+move, 640);
		ObjSprite2D_SetSourceRect(cdbg3a, move/5, move, 384+move/5, 448+move);
		
		let step2 = 145*sin(step*0.025);
		ObjRender_SetAngleZ(cdbg2a, step*0.2);
		ObjRender_SetColor(cdbg2a, 96, 0, 48+48*cos(step*0.2));
		
		
		
		
		yield;
	}
	ObjRender_SetAlpha(cdbg1a, fade);
	ObjRender_SetAlpha(cdbg2a, fade*0.65);
	ObjRender_SetScaleXYZ(cdbg2a, 1, 1, 1);
	ScreenShatterA1(27, 27);
	yield;
	Obj_Delete(cdbg1a);
	Obj_Delete(cdbg2a);
	Obj_Delete(cdbg3a);
	yield;
//	CloseScript(GetOwnScriptID);

}

task ScreenShatterA1(minpri, maxpri){
	let renderTexture = "SpellBGShatter";
	let count = 0;
	let pathShader = GetMainStgScriptDirectory~"ds_system/shader/mask.hlsl";
	let pathMask = GetMainStgScriptDirectory~"ds_system/img/Masks/glass.png";
	if(!CreateRenderTarget(renderTexture)){
	RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	SetInvalidRenderPriorityA1(minpri, maxpri);
	Reset2DCamera;
	RenderToTextureA1(renderTexture, minpri, maxpri, true);
	ClearInvalidRenderPriority;
	
	let objShader = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjShader_SetShaderF(objShader, pathShader);
	ObjShader_SetTechnique(objShader, "TecMask");

	ObjShader_SetTexture(objShader, "textureMask_", renderTexture);
	SetShaderI(objShader, maxpri, maxpri);
	
	let countx = 30;
	let county = 10;
	ascent(x in 0..countx){
		ascent(y in 0..county){
			CreateFragmentA1(GetStgFrameWidth/countx*x+rand(-16, 16), GetStgFrameHeight/county*y+rand(-16, 16));
		}
	}
	yield;
	while(count > 0){yield;}
	ObjShader_ResetShader(objShader);
	ResetShaderI(maxpri, maxpri);
	RemoveTexture(renderTexture);
	Obj_Delete(objShader);
	
	
	task CreateFragmentA1(x, y){
		count++;
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		ObjRender_SetAlpha(obj, 255);
		Obj_SetRenderPriority(obj, maxpri/100);
		ObjPrim_SetTexture(obj, pathMask);
		let ranxy = [round(rand(0,7)), round(rand(0,7))];
		ObjRender_SetScaleXYZ(obj, 1.5, 1.5, 1.5);
		ObjSprite2D_SetSourceRect(obj, ranxy[0]*48, ranxy[1]*48, (ranxy[0]+1)*48, (ranxy[1]+1)*48);
		ObjSprite2D_SetDestCenter(obj);
		
		let mid = GetStgFrameWidth/2;
		let data = [0, 0, 0, 
		(((x-mid)/mid)*rand(0, 5) + rand(-1,1))*2, 
		(2-absolute((x-mid)/mid)*3+rand(-1, 2))*0.70];
		
		let datamov = [rand(-8, 8), rand(-8, 8), rand(-8, 8), 0, 0.022];
		ObjRender_SetPosition(obj, x, y, 0);
		ObjRender_SetAngleXYZ(obj, data[0], data[1], data[2]);
		while(y<GetStgFrameHeight+64&&x<GetStgFrameWidth+64&&x>-64){
			ObjRender_SetPosition(obj, x, y, 0);
			ObjRender_SetAngleXYZ(obj, data[0], data[1], data[2]);
			
			
			data += datamov;
			datamov[4] = datamov[4]*1.06;
			x += data[3];
			y += data[4];
			
			yield;
		}
		Obj_Delete(obj);
		count--;
	}
}

function CreateBackgroundImageA1(image, rect, pri, scale){
	let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
	ObjRender_SetAlpha(BG2PropObj, 0);
	Obj_SetRenderPriority(BG2PropObj, pri);
	ObjPrim_SetTexture(BG2PropObj, image);
	ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, rect, rect);
	ObjSprite2D_SetDestCenter(BG2PropObj);
	ObjRender_SetScaleXYZ(BG2PropObj, scale, scale, 1);
	return BG2PropObj;
}
function CreateBackgroundImageB1(image, rect, pri, scale, left, top, right, bottom){
	let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
	ObjRender_SetAlpha(BG2PropObj, 0);
	Obj_SetRenderPriority(BG2PropObj, pri);
	ObjPrim_SetTexture(BG2PropObj, image);
	ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, rect, rect);
	ObjSprite2D_SetDestRect(BG2PropObj, left, top, right, bottom);
	ObjRender_SetScaleXYZ(BG2PropObj, scale, scale, 1);
	return BG2PropObj;
}



